<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="cs">
<head>




  
  
  
  
  <meta content="text/html; charset=ISO-8859-1" http-equiv="content-type">




  
  
  
  
  <title>Devbook</title>
</head>


<body>




<div style="text-align: center;">
<h1><span style="font-weight: bold; color: rgb(195, 21, 26);">ZeX/OS</span></h1>




<span style="font-weight: bold;">Developer's book for v0.4.1<br>




&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;writed by ZeXx86<br>




<br>




</span>
<div style="text-align: left;"><span style="font-weight: bold;"></span><br>




<span style="font-weight: bold;"></span></div>




<span style="font-weight: bold;"><br>




<br>




1. System calls<br>




2. Assembler tutorial<br>



3. C tutorial<br>


4. Glibc<br>
5. Filesystem driver tutorial<br>




<br>




</span>
<hr style="width: 100%; height: 2px;"><br>




<br>




<div style="text-align: left;">
<span style="font-weight: bold;">1. &nbsp;&nbsp;&nbsp; &nbsp; System calls<br>



<br>



</span>
In <a href="http://en.wikipedia.org/wiki/Computing" title="Computing">computing</a>, a <b>system call</b> is the mechanism used by an application program to request service from the <a href="http://en.wikipedia.org/wiki/Operating_system" title="Operating system">operating system</a>.<br>




ZeX/OS uses this implementation on <a href="http://en.wikipedia.org/wiki/X86" title="X86">x86</a> where the system call number is placed in the EAX <a href="http://en.wikipedia.org/wiki/Processor_register" title="Processor register">register</a> before interrupt 0x80 is executed.<br>



&nbsp;
<table style="text-align: left; width: 883px; height: 247px;" border="1" cellpadding="2" cellspacing="2">




  <tbody>




    <tr>




      <td style="text-align: center; background-color: rgb(51, 204, 255); font-weight: bold; font-style: italic;" valign="undefined">Name</td>




      <td style="background-color: rgb(51, 204, 255); text-align: center; font-weight: bold; font-style: italic;" valign="undefined">Description</td>




      <td style="text-align: center; font-weight: bold; font-style: italic; background-color: rgb(51, 255, 255);" valign="undefined">%eax</td>




      <td style="text-align: center; font-weight: bold; font-style: italic; background-color: rgb(51, 255, 255);" valign="undefined">%ebx</td>




      <td style="text-align: center; font-weight: bold; font-style: italic; background-color: rgb(51, 255, 255);" valign="undefined">%ecx</td>




      <td style="text-align: center; font-weight: bold; font-style: italic; background-color: rgb(51, 255, 255);" valign="undefined">%edx</td>




      <td style="font-weight: bold; font-style: italic; text-align: center; background-color: rgb(51, 255, 255);" valign="undefined">$0x9000</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_exit</td>




      <td style="text-align: center;" valign="undefined">Exit app at call point</td>




      <td style="text-align: center;" valign="undefined">1</td>




      <td style="text-align: center;" valign="undefined">int</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_getch</td>




      <td style="text-align: center;" valign="undefined">Get a pressed character</td>




      <td style="text-align: center;" valign="undefined">2</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">unsigned char</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_sleep</td>




      <td style="text-align: center;" valign="undefined">Wait until time (in sec) pass</td>




      <td style="text-align: center;" valign="undefined">3</td>




      <td style="text-align: center;" valign="undefined">unsigned int</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_putch</td>




      <td style="text-align: center;" valign="undefined">Print a character on the screen</td>




      <td style="text-align: center;" valign="undefined">4</td>




      <td style="text-align: center;" valign="undefined">char</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_color</td>




      <td style="text-align: center;" valign="undefined">Set color to next text</td>




      <td style="text-align: center;" valign="undefined">5</td>




      <td style="text-align: center;" valign="undefined">unsigned int</td>




      <td style="text-align: center;" valign="undefined">unsigned int</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_cls</td>




      <td style="text-align: center;" valign="undefined">Clear a screen</td>




      <td style="text-align: center;" valign="undefined">6</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_getkey</td>




      <td style="text-align: center;" valign="undefined">Get a keycode</td>




      <td style="text-align: center;" valign="undefined">7</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">unsigned char</td>




    </tr>




    <tr>




      <td style="text-align: center;" valign="undefined">sys_gotoxy</td>




      <td style="text-align: center;" valign="undefined">Move a cursor to another place</td>




      <td style="text-align: center;" valign="undefined">8</td>




      <td style="text-align: center;" valign="undefined">unsigned int</td>




      <td style="text-align: center;" valign="undefined">unsigned int</td>




      <td style="text-align: center;" valign="undefined">-</td>




      <td style="text-align: center;" valign="undefined">-</td>




    </tr>




  
  
  
  
  </tbody>
</table>




</div>




<div style="text-align: left;"><br>



<span style="font-weight: bold;">2.&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; Assembler tutorial &nbsp;<br>



</span><br>



<span style="font-weight: normal;">For people interested in assembler programming for ZeX/OS is small example of source code for <span style="font-style: italic;">nasm</span> </span><span style="font-weight: normal;">compiler.</span><span style="font-weight: bold;"></span><br>



<span style="font-weight: bold;"><br>



<span style="font-weight: bold;"></span></span><span style="font-style: italic;">&gt;File start.asm&lt;<br>



</span>
<table style="text-align: left; background-color: rgb(234, 234, 234); width: 521px; height: 544px;" border="0" cellpadding="2" cellspacing="2">



  <tbody>



    <tr>



      <td>[BITS 32]&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp; ; first, we need tell to compiler, that we
want work in 32bit mode<br>



global _start&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; ; entry point<br>



_start: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ; define of _start function<br>



&nbsp;&nbsp;&nbsp; jmp main&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;; jump to main function<br>



      <br>



      <br>



cls:&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp; &nbsp;;
clear screen function<br>



&nbsp;&nbsp;&nbsp; mov eax, 6&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp; &nbsp;; system call number 6<br>



&nbsp;&nbsp;&nbsp; int 0x80&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp; &nbsp;; call interrupt for system call
- 0x80<br>



&nbsp;&nbsp;&nbsp; ret&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; ; end of cls function<br>



      <br>



putch:&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; ; print
chatacter on the screen<br>



&nbsp;&nbsp;&nbsp; mov ebx, '.' &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;; we want print character '.'<br>



&nbsp;&nbsp;&nbsp; mov eax, 4 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ; this is system call number 6<br>



&nbsp;&nbsp;&nbsp; int 0x80&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;; system call interrupt<br>



&nbsp;&nbsp;&nbsp; ret&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;; end of putch function<br>



      <br>



      <br>



main:&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp; ; main function<br>



&nbsp;&nbsp;&nbsp; call cls&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;; this clear a screen<br>



      <br>



&nbsp;&nbsp;&nbsp; mov cl, 10&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp; ; set number 10 to register cl<br>



nav:<br>



&nbsp;&nbsp;&nbsp; dec cl&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp; ; decrease one number from
register cl<br>



&nbsp;&nbsp;&nbsp; call putch&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;; print charecter '.' on the screen<br>



&nbsp;&nbsp;&nbsp; jnz nav&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;; will be jump to nav until
cl is'nt zero<br>



      <br>



&nbsp;&nbsp;&nbsp; ret&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;
&nbsp;; here ends our program<br>



      </td>



    </tr>



  
  
  
  </tbody>
</table>



<br>



For compile, you need <span style="font-style: italic;">nasm</span> compiler and <span style="font-style: italic;">ld</span> for link object.<br>



nasm -f elf -ostart.o start.asm<br>



ld -m elf_i386 -s -omyapp start.o<br>



<span style="font-style: italic;"></span><span style="font-weight: bold;"><span style="font-weight: bold;"></span></span><br>



<br>



<span style="font-weight: bold;">3. &nbsp;&nbsp;&nbsp; &nbsp;C tutorial<br>



<br>



<span style="font-weight: bold;"><span style="font-weight: bold;"></span></span></span><span style="font-weight: normal;">For people interested in C programming language for ZeX/OS is small example of source code for </span><span style="font-style: italic; font-weight: normal;">gcc</span><span style="font-weight: normal;"> compiler.<br>



</span><span style="font-weight: bold;"><span style="font-weight: bold;"></span><br>



</span><span style="font-style: italic;">&gt;File main.c&lt;</span><span style="font-style: italic;"><br>



</span>
<table style="text-align: left; background-color: rgb(234, 234, 234); height: 237px; width: 381px;" border="0" cellpadding="2" cellspacing="2">



  <tbody>



    <tr>



      <td>#include &lt;stdio.h&gt;<br>



      <br>



int main ()<br>



{<br>



&nbsp; &nbsp; &nbsp; &nbsp; puts ("Hello world !");<br>



&nbsp; &nbsp; &nbsp; &nbsp; putch ('\n');<br>



      <br>



&nbsp; &nbsp; &nbsp; &nbsp; int a = 8;<br>



&nbsp; &nbsp; &nbsp; &nbsp; int b = 5;<br>



&nbsp; &nbsp; &nbsp; &nbsp; int result = a + b;<br>



      <br>



&nbsp; &nbsp; &nbsp; &nbsp; printf ("a + b = result\n%d + %d = %d", a, b, result);<br>



      <br>



&nbsp; &nbsp; &nbsp; &nbsp; return 1;<br>



}<br>



      </td>



    </tr>



  
  
  
  </tbody>
</table>


<br>


<br>


<br>


<span style="font-weight: bold;">4.&nbsp;&nbsp;&nbsp; &nbsp; Glibc<br>


<br>


<span style="font-weight: bold;"></span></span>The GNU C Library,
commonly known as glibc, is the C standard library released by the GNU
Project. Originally written by the Free Software Foundation (FSF) for
the GNU operating system, the library's development has been overseen
by a committee since 2001, with Ulrich Drepper as the lead contributor
and maintainer.<br>


<br>


This version of glibc is completly written by&nbsp;<span style="font-style: italic;">ZeXx86</span> for light compatibility with GNU programs written in C programming languague on ZeX/OS.<br>


<br>


<span style="text-decoration: underline;">Include layout<br>


<br>


</span>#include &lt;stdio.h&gt;<span style="font-style: italic;"></span><br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 608px; height: 164px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>
      
      
      <div style="text-align: left;">void putch (char c); //&nbsp;Print a character on the screen </div>


void puts (unsigned char *text); // Print a string<br>


void printf (const char *fmt, ...); // Same as puts but with arguments<br>


void cls (); // Clear a screen<br>


unsigned char getch (); // Get a pressed character<br>


unsigned char getkey (); // Get a keycode<br>


void gotoxy (int x, int y); // Move a cursor to another place<br>


void setcolor (int t, int f); // Set color to next text<br>

int sprintf(char *buffer, const char *fmt, ...); // Copy string fmt with args to buffer
      </td>



    </tr>



  
  
  
  </tbody>
</table>


<br>


#include &lt;stdlib.h&gt;<span style="font-style: italic;"></span><br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 608px; height: 88px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>void *malloc (size_t size); // Allocate block of memory<br>


void *realloc (void *blk, size_t size); // Allocate next block of memory<br>


void free (void *blk); // Free a block of allocated memory<br>


void exit (); //&nbsp;Exit app at call point
      </td>



    </tr>



  
  
  
  </tbody>
</table>


<br>


#include &lt;unistd.h&gt;<span style="font-style: italic;"></span><br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 607px; height: 31px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>unsigned int sleep (unsigned int) // Wait until time (in sec) pass
      </td>



    </tr>



  
  
  
  </tbody>
</table>


<br>


#include &lt;string.h&gt;<br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 756px; height: 164px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>void *memcpy (void *dst_ptr, const void *src_ptr, size_t count); // Copy block of memory<br>


void *memsetw (void *dst, int val, size_t count); // Put to memory block of&nbsp;some character<br>


void *memset (void *dst, int val, size_t count); // Put to memory block of&nbsp;some character<br>


size_t strlen (const char *str); // Get length of string<br>


char *strcpy (char *to, const char *from); // Copy string<br>

char *strncpy (char *s1, const char *s2, size_t n); // Copy string with declared length<br>


char *strcat (char *s, const char *add); // Add string to another string<br>


int strcmp (const char *cs, const char *ct); // Compare two strings<br>


int strncmp (const char *cs, const char *ct, size_t count); // Compare two strings with defined length<br>

char *strdup (const char *s); // Alloc new block of memory for string s<br>



      </td>



    </tr>



  
  
  
  </tbody>
</table>


<br>


#include &lt;x86.h&gt;<span style="font-style: italic;"></span><br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 403px; height: 126px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>unsigned inportb (unsigned short port); // Get byte from port<br>


void outportb (unsigned port, unsigned val); // Set byte on port<br>


unsigned disable (void); // Disable interrupts<br>


void enable (void); // Enable interrupts<br>


void enable_irq (unsigned short irq_num); // Enable irq<br>


void disable_irq (unsigned short irq_num); // Disable irq
      </td>



    </tr>



  
  
  
  </tbody>
</table>
<br>
<br>
<span style="font-weight: bold;">5.&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;</span><span style="font-weight: bold;">Filesystem driver tutorial<br>
<br>
</span>ZeX/OS is developed for no one filesystem, so it supports fs handlers, disk handlers, etc..<br>
As you should see, in this short tutorial, you will learn how it works<br>
<br>
<br>
Base function to read/write data over disk<span style="font-style: italic;"></span><br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 593px; height: 126px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>/* partition_t is defined in partition.h, addr is 28bit
(32) address of block, easy addr = 1 is block 1, etc .. buffer is
classical char * for getting data after calling */<br>
int lba28_drive_read (partition_t *p, unsigned int addr, unsigned char *buffer);<br>
      <br>
/* same, but for writing data from buffer */<br>
int lba28_drive_write (partition_t *p, unsigned char addr, unsigned char *buffer);<br>
      <br>
/* when you want device metod, use this */<br>
dev_t *dev = dev_findbypartition (p);<br>
      <br>
if (!dev) // check for existing device<br>
&nbsp;&nbsp;&nbsp; return 0;<br>
      <br>
if (!dev-&gt;handler (DEV_ACT_READ, p, block, more, n))<br>
&nbsp;&nbsp;&nbsp; return 0; // error ?<br>
      <br>
/* handler is defined in drive.c and function shows like this */<br>
bool ide_acthandler (unsigned act, partition_t *p, char *block, char *more, int n)<br>

      </td>



    </tr>



  
  
  
  </tbody>
</table>
<br>
<br>
myfs.c<span style="font-style: italic;"></span><br>


<table style="text-align: left; background-color: rgb(234, 234, 234); width: 687px; height: 1057px;" border="0" cellpadding="2" cellspacing="2">


  <tbody>


    <tr>


      <td>#include &lt;partition.h&gt;<br>
#include &lt;system.h&gt;<br>
#include &lt;string.h&gt;<br>
#include &lt;dev.h&gt;<br>
#include &lt;fs.h&gt;<br>
      <br>
      <br>
bool myfs_read_dir (partition_t *p, char *block, int n)<br>
{<br>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;/* its your space for create
function, which read directory and put it to dir[] structure, <br>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;dir is defined in system.h include */<br>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;return 1;<br>
}<br>
      <br>
/*<br>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;...<br>
*/<br>
      <br>
/** MyFS handler for handling disk operations<br>
&nbsp;*&nbsp; act - action; arg - argument; block - chunk of data for
input/output; n - number of block; l - lenght of &nbsp;output<br>
&nbsp;*/<br>
bool myfs_handler (unsigned act, unsigned arg, char *block, unsigned n, unsigned long l)<br>
{<br>
&nbsp;&nbsp;&nbsp; switch (act) {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; case FS_ACT_INIT:<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; /* something, what&nbsp;you need to initialize, e.g. memory stacks */<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; return 1;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; }<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; break;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; case FS_ACT_READ:<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; switch (arg) {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; case FS_ARG_FILE:<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp; &nbsp;myfs_read_file (curr_part, n); //
this have to read file at n block on partition_t *curr_part<br>
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; /* ... some stuff for get new data on char *block */<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; return 1;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; }<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; break;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; case FS_ARG_DIR:<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; myfs_read_dir (curr_part, n); //
this is your new fs function too<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; /* same as in file operation */<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; return 1;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; }<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; break;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; }<br>
      <br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; return 0;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; }<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; break;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; case FS_ACT_WRITE:<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; {<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; /* Yeah, you
want to probably create FS with write support, you can do it here */<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; return 1;<br>
&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; }<br>
&nbsp;&nbsp;&nbsp; }<br>
      <br>
&nbsp;&nbsp;&nbsp; return 0;<br>
}<br>

      </td>



    </tr>



  
  
  
  </tbody>
</table>

<br>
<span style="font-weight: bold;">&nbsp;&nbsp;&nbsp;</span><span style="font-weight: bold;"></span></div>





</div>




</body>
</html>
